<?php 
error_reporting(E_ALL);
ini_set('display_errors', '1');

$url="http://192.168.0.77";
$title="Heating Interface Demo";
$CookieTime=3600*24;
$domain="hi.oscs.uk";

cookies();



#echo "...";
#exit;

head();

if (isset($_GET['m'])){
	$m=$_GET['m'];
	switch($m){
		case "savesettings": SaveSettings(); break;
	
	}
}

display();

foot();


###############################################################
function SaveSettings(){
global $url;
	echo "<p>I'm checking what you have asked me to do...</p><p>";
#print_r($_GET);
	
	$a=0;
	if (isset($_GET['a1'])) {$a1=$_GET['a1'];$a++;} else {$a1=999;}
	if (isset($_GET['a2'])) {$a2=$_GET['a2'];$a++;} else {$a2=999;}
	if (isset($_GET['a3'])) {$a3=$_GET['a3'];$a++;} else {$a3=999;}
	if (isset($_GET['a4'])) {$a4=$_GET['a4'];$a++;} else {$a4=999;}
	if ($a>0){
		$command="?a1=$a1&a2=$a2&a3=$a3&a4=$a4";
		$x=file("$url/$command");
		echo "<div style='border:2px dashed red;padding:10px;'>";
		echo "I have just sent a multi-arguement command to the controller:<br>";
		echo "<span style='font-family:courier;font-size:20px;color:green;'>$command</span></div>";
	}
	
	$command='';
	if (isset($_GET['r1'])) { if (strlen($command)>0) $command.='&'; $command.="r1=".$_GET['r1']; }
	if (isset($_GET['r2'])) { if (strlen($command)>0) $command.='&'; $command.="r2=".$_GET['r2']; }
	if (isset($_GET['r3'])) { if (strlen($command)>0) $command.='&'; $command.="r3=".$_GET['r3']; }
	if (isset($_GET['r4'])) { if (strlen($command)>0) $command.='&'; $command.="r4=".$_GET['r4']; }
#echo "COMMAND: $command<br>";	
	if (strlen($command)>0){
		$x=file("$url/?m=savesettings&$command");
		echo "<div style='border:2px dashed red;padding:10px;'>I have sent a command to change the state of RLA1:<br>";
		echo "<span style='font-family:courier;font-size:20px;color:green;'>$command</span><br><B>NOTE:</b> relay state will not be ";
		echo "changed by manual control if a relay is configure to be automatic - to turn off auto for a ";
		echo "relay change it's auto-temp setting to 999.</div>";
	}
	echo "</p>";
	
}
###############################################################
function display(){
global $title;	
	echo "<h1>$title</h1><h4>
	      As this is demo software for the purpose of showing how the Heating Interface can be controlled,
	      HTML/CSS/PHP coding may not be what would normally be considered \"best practice\".
	      </h4><hr>";
	list($state,$temp,$a1,$a2,$a3,$a4)=ReadHI();
	if ($a1>=999) {$aa1="<span style='color:red;'>OFF</span>";} else {$aa1=$a1.'&deg;C';}
	if ($a2>=999) {$aa2="<span style='color:red;'>OFF</span>";} else {$aa2=$a2.'&deg;C';}
	if ($a3>=999) {$aa3="<span style='color:red;'>OFF</span>";} else {$aa3=$a3.'&deg;C';}
	if ($a4>=999) {$aa4="<span style='color:red;'>OFF</span>";} else {$aa4=$a4.'&deg;C';}

	echo "<h2>Tempreature, Relays Status and Auto Settings</h2>";
	echo "<table border=0><tr><td width='50%'>";
	echo "<table border=0>
	<tr><td><b>RELAY STATE (RLA4/RLS3/RLS2/RLA1): </b></td><td>$state</td></tr>
	<tr><td><b>TEMPERATURE: </b></td><td>$temp&deg;C</td></tr>
	<tr><td><b>AUTO RLA1 TEMP: </b></td><td>$aa1</td></tr>
	<tr><td><b>AUTO RLA2 TEMP: </b></td><td>$aa2</td></tr>
	<tr><td><b>AUTO RLA3 TEMP: </b></td><td>$aa3</td></tr>
	<tr><td><b>AUTO RLA4 TEMP: </b></td><td>$aa4</td></tr>
	</table>";
	
	echo "</td><td width='50%'>";
	
	echo "<div style='font-family:dots; font-size:100px; padding:20px; border:4px ridge black;background:#C0CEFC;text-align:right; width:350px;'>$temp C</div>";
	
	echo "</td></tr></table>";
	
	echo "<hr>";
	echo "<h2>Change Settings</h2>";
	echo "<table border=0 width='100%' style='padding:5px;'><tr>";
	echo "<td width='50%' style='vertical align:top;border:1px dashed black;padding:5px;'>";
	echo "<h3>Auro-relay Settings</h3>";
	echo "<form method='GET'><input type='hidden' name='m' value='savesettings'>
			<table border=0>
			<tr><td><b>SET AUTO RLA1 TEMP: </b></td><td><input name='a1' value='$a1' size='4'>&deg;C <sup>*</sup></td></tr>
			<tr><td><b>SET AUTO RLA2 TEMP: </b></td><td><input name='a2' value='$a2' size='4'>&deg;C <sup>*</sup></td></tr>
			<tr><td><b>SET AUTO RLA3 TEMP: </b></td><td><input name='a3' value='$a3' size='4'>&deg;C <sup>*</sup></td></tr>
			<tr><td><b>SET AUTO RLA4 TEMP: </b></td><td><input name='a4' value='$a4' size='4'>&deg;C <sup>*</sup></td></tr>
			
			</table>
			<sup>*</sup> set to 999 to turn off auto-function<br>
			<input type='submit' value='SAVE AUTO SETTINGS'><br>
			</form>";
	echo "</td><td width='50%' style='vertical align:top;border:1px dashed black;padding:5px;'>";
	
	echo "<h3>Change Relays State</h3><p>This will only work for relays that are not configure to auto-switch at a set temperature.</p>";
	echo "<form method='GET'><input type='hidden' name='m' value='savesettings'>
			<table border=0>
			<tr><td><b>RLA1: </b></td><td><a href=/?m=savesettings&r1=0>[OFF]</a> <a href=/?m=savesettings&r1=1>[ON]</a></td></tr>
			<tr><td><b>RLA2: </b></td><td><a href=/?m=savesettings&r2=0>[OFF]</a> <a href=/?m=savesettings&r2=1>[ON]</a></td></tr>
			<tr><td><b>RLA3: </b></td><td><a href=/?m=savesettings&r3=0>[OFF]</a> <a href=/?m=savesettings&r3=1>[ON]</a></td></tr>
			<tr><td><b>RLA4: </b></td><td><a href=/?m=savesettings&r4=0>[OFF]</a> <a href=/?m=savesettings&r4=1>[ON]</a></td></tr>
			
			</table>
			<a href=/?m=savesettings&r1=0&r2=0&r3=0&r4=0>[ALL OFF]</a> <a href=/?m=savesettings&r1=1&r2=1&r3=1&r4=1>[ALL ON]</a>
			</form>";
	
	echo "</td></tr></table>";
	
}

###############################################################
function ReadHI(){
global $url;
	$page=file($url);
	$state=$page[1];
	$temp=$page[2];
	$a1=$page[3];
	$a2=$page[4];
	$a3=$page[5];
	$a4=$page[6];
	return array($state,$temp,$a1,$a2,$a3,$a4);
	
}

###############################################################
function cookies(){
global $starttime,$endtime,$CookieTime,$domain;	

	if (isset($_REQUEST['starttime'])){
		$starttime=$_REQUEST['starttime'];
	} else if (isset($_COOKIE['starttime'])){
		$starttime=$_COOKIE['starttime'];    
	} else {
		$starttime='8:00';  
	}
	setcookie("starttime",$starttime,time()+$CookieTime ,"/",$domain,isset($_SERVER["HTTPS"]));
	
	if (isset($_REQUEST['endtime'])){
		$endtime=$_REQUEST['endtime'];
	} else if (isset($_COOKIE['endtime'])){
		$endtime=$_COOKIE['endtime'];    
	} else {
		$endtime='22:00';  
	}
	setcookie("endtime",$endtime,time()+$CookieTime ,"/",$domain,isset($_SERVER["HTTPS"]));

	
}



###############################################################
function head(){
global $title;
	echo "<!DOCTYPE HTML PUBLIC\"-//W3C//DTD HTML 4.0 Transitional//EN\"><html><head title='$title'>
		<title>$title</title><link rel='shortcut icon' href='/favicon.png'>
		<link rel='stylesheet' href='/style.css' type='text/css'>";
	echo "</head><body><p>&nbsp;</p>";
	echo "<center><table width=800 border=0><tr><td>";


		 

}

###############################################################
function foot(){
	echo "</td></tr>";
	echo "<tr><td><hr><div style='font-size:9px;'>NOTES:<ol>";
	echo "<li>This demo is in no way meant to represent perfect or even good code,
			it is intended only as a tool to show how to connect to and control the
			Heating Interface.</li>
			<li>In a real world environment there would be multip on/off
			times which would be stored in a database.  </li>
			</ol>
			";
	echo "</div></td></tr>";
	echo "</table></center></body></html>";
}

